

/// This is a decoder module
module Decoder (
input  logic[3:0]   in,          ///< 4 bit binary input
output logic[15:0]  result,      ///< 16-bit result 
output logic        sync,        ///< Output from the very nice sync thingy
input  logic        enable       ///< Enable for the decoder
);

assign sync = result[0] || (result[1] && result[2]); ///< This is a strange sync signal that might be useful 

/// This module implements some random stuff
always_comb begin : decoder_comb
  result = 0;
  if (enable) begin
    case (in)
      4'h0 : result = 16'hA0C1; // A comment
      4'h1 : result = 16'h0102;
      4'h2 : result = 16'hD303;
      4'h3 : result = 16'hC104;
      4'h4 : result = 16'h0205;
      4'h5 : result = 16'h0D06;
      4'h6 : result = 16'hAC07;
      4'h7 : result = 16'h0F08;
      4'h8 : result = 16'h0569;
      4'h9 : result = 16'hC040;
      4'hA : result = 16'hA011;
      4'hB : result = 16'h4C12;
      4'hC : result = 16'hAF13;
      4'hD : result = 16'h0C14;
      4'hE : result = 16'hC5A5;
      4'hF : result = 16'h0C16;
    endcase
  end
end : decoder_comb

endmodule

