/// This module tests the Top module
module test_Top();
  
  logic ck;           ///< The clock
  logic reset_N;      ///< Reset signal. Active low.
  logic[31:0] result; ///< Result is stored here.
  
  /// Simgple clock generator
  always begin
    #100;             
    ck = ~ck;  
  end
  
  /// Test bench
  initial begin
    ck = 0;
    reset_N = 0; 
    @(posedge ck);
    @(posedge ck);    
    reset_N = 1;    
  end

 /// Top instantiation 
 ///
 Top u_Top(
  .ck         (ck),
  .reset_N    (reset_N),
  .result     (result)
  ); 
 
endmodule : test_Top


   
